
%{
#include <cstdlib>
#include "grammar_parser.hpp"
#include "lexer.hpp"

// The loc of the current token.
static grammar::location loc;
    
#undef  YY_DECL
#define YY_DECL grammar::parser::symbol_type grammar::lexer::yylex(int)
%}


%option             c++ noyywrap nounput noinput batch never-interactive
%option outfile=    "grammar_lexer.cpp"
%option yyclass=    "lexer"

%{
// Code run each time a pattern is matched.
#define YY_USER_ACTION loc.columns(yyleng);
%}

B       [ \t]
L       [a-zA-Z]
I       [0-9]   


%%

%{
// Code run each time yylex is called.
loc.step();
%}

{B}+        {loc.step();                                                            }
[\n]+       {loc.lines(yyleng); loc.step();                                         }

";"         {return grammar::parser::make_SEMICOLON(loc);                           }
{L}         {return grammar::parser::make_CHAR(*yytext,loc);                        }
{I}         {return grammar::parser::make_CHAR(std::atoi(yytext),loc);              }
<<EOF>>     {return grammar::parser::make_END(loc);                                 }

%%

