
%require        "3.0"
%skeleton       "lalr1.cc"
%output         "grammar_parser.cpp"
%defines
%language       "c++"

%define         api.namespace           {grammar}
%define         parser_class_name       {parser}
%define         api.token.prefix        {TOK_}
%define         api.token.constructor
%define         api.value.type          variant
%define         parse.assert
%define         parse.error             verbose

%code requires
{
    namespace grammar
    {
        class lexer;
    }
}

%param          {grammar::lexer& l}
%locations

%code
{
#include <iostream>
#include "lexer.hpp"
static grammar::parser::symbol_type yylex(grammar::lexer&);
}

%token <char> CHAR          "char"
%token <int>  NUM           "number"
%token        SEMICOLON     ";"
%token        END   0       "end of file"

%%

stms : stms CHAR ";"
     | CHAR ";"        
     | error ";"        {yyerrok;}
     ;

%%


// calls the given lexer 
grammar::parser::symbol_type yylex(grammar::lexer& l)
{
    return l.yylex(0);
}

void grammar::parser::error(const location_type& loc, const std::string& msg)
{
    std::cerr << loc << " " << msg << std::endl;
}
